/*******************************************************************************/
/*****	Methods		************************************************************/
/*******************************************************************************/

METHOD sie_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	CLASS		INPUT;
	DEFINITION
	{
	}
}

METHOD polling_address_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	CLASS		INPUT;
	DEFINITION
	{
		ACKNOWLEDGE([message_polling_address]);
	}
}

/*******************************************************************************/
/*****	MENU Bar  **************************************************************/
/*******************************************************************************/

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		/*Menu_Edit,*/
		Menu_S_Device,
		Menu_View,
		Menu_Options,
		Menu_Help
	}
}

MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_View,
		Menu_Options,
		Menu_Help
	}
}

/*---------------------------------------------------------------------*/
/*    Menu: File													   */
/*---------------------------------------------------------------------*/

#include "SI_FileM.inc"

/*---------------------------------------------------------------------*/
/*    MENU: Device													   */
/*---------------------------------------------------------------------*/

MENU Menu_S_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
			std_CommWay,
//			SEPARATOR,
//			OnlineDialog_Device_NodeAddress,
			SEPARATOR,
			std_LoadinDevice,
			std_LoadinPC,
			SEPARATOR,
			//OnlineDialog_selftest,?
			OnlineDialog_simulation,
			SEPARATOR,
			OnlineDialog_totalizer_reset,
			master_reset_method,
			SEPARATOR,
			//OnlineDialog_SV_map,
			OnlineDialog_zero_trim,
OnlineDialog_DAC_trim,//dac_trim,
			//burn_eeprom,
			SEPARATOR,
			configuration_flag_reset,
			OnlineDialog_hart_comm
	}
}

MENU Menu_M_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
			std_LoadinDevice,
			std_LoadinPC,
			SEPARATOR,
			//OnlineDialog_selftest,?
			OnlineDialog_simulation,
	}
}

METHOD std_CommWay
{
	LABEL		[menu_Device_CommWay];
	DEFINITION
	{
	}
}

METHOD std_LoadinDevice
{
	LABEL		[menu_Device_LoadinDevice];
	DEFINITION
	{
	}
}

METHOD std_LoadinPC
{
	LABEL		[menu_Device_LoadinPC];
	DEFINITION
	{
	}
}

/*---------------------------------------------------------------------*/
/*    MENU: View													   */
/*---------------------------------------------------------------------*/

MENU Menu_View
{
	LABEL		[menu_View];
	ITEMS
	{
			OnlineWindow_display,
		//	OnlineWindow_yt,
			OnlineWindow_diagnosis,
			SEPARATOR,
			std_Funktionsleiste,
			std_Statuszeile,
			SEPARATOR,
			std_Update
	}
}

METHOD std_Funktionsleiste
{
	LABEL		[menu_View_Toolbar];
	DEFINITION
	{
	}
}

METHOD std_Statuszeile
{
	LABEL		[menu_View_Statusbar];
	DEFINITION
	{
	}
}

METHOD std_Update
{
	LABEL		[menu_View_Update];
	DEFINITION
	{
	}
}

METHOD configuration_flag_reset
{
	LABEL		[configuration_flag_reset];
	HELP		[configuration_flag_reset_help];
	CLASS		INPUT;
	DEFINITION
	{
		int		choice;
		char	disp_string1[60];
		char	disp_string2[60];
		int		slen1;
		int		slen2;

		slen1=60;
		slen2=60;

		get_dictionary_string(configuration_flag_reset_execute, disp_string1, slen1);
		get_dictionary_string(yes_no, disp_string2, slen2);

		choice= SELECT_FROM_LIST(disp_string1, disp_string2);
		if ( choice == 0 )
		{
			send_command(38);
		}
	}
}

/*---------------------------------------------------------------------*/
/*    MENU: Options													   */
/*---------------------------------------------------------------------*/

#include "SI_OptM.inc"

/*---------------------------------------------------------------------*/
/*    MENU: Help													   */
/*---------------------------------------------------------------------*/

#include "SI_HlpM.inc"

/*******************************************************************************/
/*****	Online-Windows  ********************************************************/
/*******************************************************************************/

MENU OnlineWindow_display
{
	LABEL	[menu_dialog_display];
	ITEMS
	{
		Page_flow_display,
Page_secondary_display,
		Page_display_out_tot
	}
}

MENU Val_velocity
{
	LABEL	"Velocity|de|Geschwindigkeit";
	ITEMS
	{
		var_velocity.DIGITAL_VALUE
	}
}

MENU Val_total_totalizer1
{
	LABEL	"Totalizer 1|de|Zhler 1";
	ITEMS
	{
		var_totalizer1.DIGITAL_VALUE
	}
}

MENU Val_total_totalizer2
{
	LABEL	"Totalizer 2|de|Zhler 2";
	ITEMS
	{
		var_totalizer2.DIGITAL_VALUE
	}

}

MENU Val_total_totalizerR
{
	LABEL	"Reverse totalizer|de|Zhler Rckflu";
	ITEMS
	{
		var_totalizerR.DIGITAL_VALUE
	}

}

MENU Val_analog_value
{
    LABEL           [analog_output_value];
	ITEMS
	{
		var_volflow.ANALOG_VALUE
	}
}

MENU Val_input_percent_range
{
    LABEL           [percent_of_range];
	ITEMS
	{
		var_volflow.PERCENT_RANGE
	}
}

MENU Page_flow_display
{
	LABEL		"Flow|de|Durchflu";//[menu_dialog_display_measure];
	ITEMS
	{
			BarVal_process_flow_display,
			Val_input_percent_range,
			Val_analog_value,
			device_status				(READ_ONLY)
	}
}

MENU Page_secondary_display
{
	LABEL	"Velocity|de|Geschwindigkeit";   //[menu_dialog_display_measure];
	ITEMS
	{
			Val_velocity
	}
}

MENU BarVal_process_flow_display
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
			var_volflow.DIGITAL_VALUE,
			var_volflow.LOWER_RANGE_VALUE	(READ_ONLY),
			var_volflow.UPPER_RANGE_VALUE	(READ_ONLY)

	}
}

MENU Page_display_out_tot
{
	LABEL	"totalizers|de|Zhler";
	ITEMS
	{
		Val_total_totalizer1,
//		Val_total_totalizer2,
		Val_total_totalizerR,
	}
}

MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_device,
		Page_diagnosis_status,
	}
}

MENU Page_diagnosis_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
			tag (READ_ONLY),
			manufacturer_id(READ_ONLY),
			device_id(READ_ONLY),
			device_type(READ_ONLY),
			date(READ_ONLY),
			universal_revision(READ_ONLY),
			transmitter_revision(READ_ONLY),
			//hardware_revision(READ_ONLY),
			software_revision(READ_ONLY),
			sensor_serial_number(READ_ONLY),
			final_assembly_number(READ_ONLY),

	}
}

MENU Page_diagnosis_status
{
	LABEL	[menu_status];
	ITEMS
	{
		Group_device_status,
		status_display
	}
}

MENU Group_device_status
{
	LABEL  "Device status""|de|Gertestatus";
	ITEMS
	{
		device_status		(READ_ONLY),
		show_counterpara_change
	}
}

/*******************************************************************************/
/*****	Online-Dialogs  ********************************************************/
/*******************************************************************************/

MENU OnlineDialog_zero_trim
  {
	LABEL  "zero_trim" "|de|Nullpunktabgleich";
	ITEMS
	{
	var_volflow.DIGITAL_VALUE,
device_status				(READ_ONLY),
	zero_trim		 //method
	}
  }

MENU OnlineDialog_DAC_trim
  {
	LABEL "trim current output|de|Stromausgang kalibrieren";
	ITEMS
	{
        dac_trim
	}
  }

MENU OnlineDialog_SV_map
{
	LABEL  "Map SV-QV|de|Bel. SV-QV";
	ITEMS
	{
		mnu_SV_map
	}
}

MENU OnlineDialog_totalizer_reset
{
	LABEL    "Reset totalizers|de|Zhler rcksetzen";
	ITEMS
	{
	reset_totl1,
	reset_totl2,
	reset_totlR
//		mnu_totalizers
	}
}

MENU OnlineDialog_selftest
{
	LABEL  [selftest];
	ITEMS
	{
		Page_selftest
	}
}

MENU OnlineDialog_simulation
{
	LABEL  [menu_interface_simulate];
	ITEMS
	{
		mnu_simulation
	}
}

MENU OnlineDialog_hart_comm
{
	LABEL		[menu_HART_Comm];
	ITEMS
	{
			Page_request_response_preambles
	}
}

MENU Page_request_response_preambles
{
	LABEL		[menu_request_response_preambles];
	ITEMS
	{
			response_preambles ,
			request_preambles ,
			sie_set
	}
}

MENU OnlineDialog_Device_NodeAddress
{
	LABEL		[menu_Device_NodeAddress];
	ITEMS
	{
			polling_address,
			polling_address_set
	}
}

/*******************************************************************************/
/*****	Upload / Download MENU  ************************************************/
/*******************************************************************************/
MENU upload_variables  /* schreiben in Feldgrt */
{
	LABEL		[menu_load_to_device];
	PRE_WRITE_ACTIONS
	{
		block_transfer_start
	}
	POST_WRITE_ACTIONS
	{
		block_transfer_stop
	}
	ITEMS
	{
		tag,
		date,

		descriptor,
		message,
//		sensor_serial_number,
		final_assembly_number,

		conf_sensor_const,
conf_sensor_zero,		
		conf_sensor_inner_width,
		conf_sensor_type,
		conf_sensor_magn_field_freq,
		conf_sensor_net_freq,

		sensor_damping_value,
		volume_flow_units,
totalizer_units_choose,

		lower_range_value,
		upper_range_value,

		conf_flow_direction,

		flow_limit_min,
		flow_limit_max,
		flow_limit_hyst,
		low_flow_cutoff,
		low_flow_cutoff_hyst,
dichte,

		conf_disp_language,
		conf_disp_initial,

		pulse_output_choice,
		pulse_width,
		pulse_factor,
		pulse_units,

		current_output_range,
		current_output_alarm,

		binary_input,
		binary_output_active_state,
		binary_output2,
		binary_output3,

		self_test_enable,
		basic_calibration_enable,
		check_empty_pipe_enable,
		self_test_period,
		basic_calibration_period,
		check_empty_pipe_period
	}
}

MENU download_variables  /* lesen aus Feldgert */
{
    LABEL   [menu_load_to_PC];

    ITEMS
    {
		// Start JF
		manufacturer_id,
		device_type,
		device_type,
		device_id,
		universal_revision,
		transmitter_revision,
		software_revision,
		write_protect,
		// End JF

		tag,
		date,

		descriptor,
		message,
		sensor_serial_number,
		final_assembly_number,

		sensor_damping_value,
		volume_flow_units,
totalizer_units_choose ,

		// Start JF
		sensor_upper_limit,
		sensor_lower_limit,
		// End JF

		lower_range_value,
		upper_range_value,

		conf_flow_direction,

		flow_limit_min,
		flow_limit_max,
		flow_limit_hyst,
		low_flow_cutoff,
		low_flow_cutoff_hyst,
dichte,
		conf_sensor_const,
conf_sensor_zero,		
		conf_sensor_inner_width,
		conf_sensor_type,
		conf_sensor_magn_field_freq,
		conf_sensor_net_freq,

		conf_disp_language,
		conf_disp_initial,

		pulse_output_choice,
		pulse_width,
		pulse_factor,
		pulse_units,

		current_output_range,
		current_output_alarm,

		binary_input,
		binary_output_active_state,
		binary_output2,
		binary_output3,

		self_test_enable,
		basic_calibration_enable,
		check_empty_pipe_enable,
		self_test_period,
		basic_calibration_period,
		check_empty_pipe_period
    }
}

  